/*
 * a jQuery plugin that extend the dropdown element to allow it bind a case insensitive value to its option list
 * */
(function ($) {

    var methods = {
        init: function () {
            return this;
        },
        bindValue: function (selectedValue) {
            var self = this,
                selectedValueLowerCase = selectedValue.toLowerCase(),
                matchValue = "";
            $("option", self).each(function () {
                var option = $(this);
                if (option.val().toLowerCase() === selectedValueLowerCase) {
                    matchValue = option.val();
                }
            });
            self.val(matchValue);
        }
    };

    $.fn.caseInsensitiveDropdown = function (methodOrOptions) {
        if (methods[methodOrOptions]) {
            return methods[ methodOrOptions ].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof methodOrOptions === 'object' || !methodOrOptions) {
            // Default to "init"
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + methodOrOptions + ' does not exist on jQuery.caseInsensitiveDropdown');
        }
    };
})(AJS.$);